<?php
namespace ystp;

class Ajax {

	public function __construct() {
		$this->init();
	}

	public function init() {
		add_action('wp_ajax_ystp-switch', array($this, 'switchCountdown'));
		add_action('wp_ajax_ystp_select2_search_data', array($this, 'select2Ajax'));
		add_action('wp_ajax_ystp_edit_conditions_row', array($this, 'conditionsRow'));
		add_action('wp_ajax_ystp_add_conditions_row', array($this, 'conditionsRow'));
	}
	
	public function switchCountdown() {
		check_ajax_referer('ystp_ajax_nonce', 'nonce');
		$postId = (int)$_POST['id'];
		$checked = $_POST['checked'] == 'true' ? '' : true;
		update_post_meta($postId, 'ystp_enable', $checked);
		
		echo 1;
		wp_die();
	}

	public function select2Ajax() {
		check_ajax_referer('ystp_ajax_nonce', 'nonce_ajax');

		$postTypeName = sanitize_text_field($_POST['postType']);
		$search = sanitize_text_field($_POST['searchTerm']);

		$args      = array(
			's'              => $search,
			'post__in'       => ! empty( $_REQUEST['include'] ) ? array_map( 'intval', $_REQUEST['include'] ) : null,
			'page'           => ! empty( $_REQUEST['page'] ) ? absint( $_REQUEST['page'] ) : null,
			'posts_per_page' => 100,
			'post_type'      => $postTypeName
		);

		$searchResults = AdminHelper::getPostTypeData($args);

		if (empty($searchResults)) {
			$results['items'] = array();
		}

		/*Selected custom post type convert for select2 format*/
		foreach ($searchResults as $id => $name) {
			$results['items'][] = array(
				'id'   => $id,
				'text' => $name
			);
		}

		echo json_encode($results);
		wp_die();
	}

	public function conditionsRow() {
		check_ajax_referer('ystp_ajax_nonce', 'nonce');
		$selectedParams = sanitize_text_field($_POST['selectedParams']);
		$conditionId = (int)$_POST['conditionId'];
		$childClassName = $_POST['conditionsClassName'];
		$childClassName = __NAMESPACE__.'\\'.$childClassName;
		$obj = new $childClassName();

		echo $obj->renderConditionRowFromParam($selectedParams, $conditionId);
		wp_die();
	}
}

new Ajax();